/*
 *    AulaChat - Advanced teacher/pupil communication system
 *    Copyright (C) 2006 James Lpez Prieto (BLuEGoD).
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *    
 *    Modulo: Gestin de la BD (MySQL)
 *
 */

#include "aulachat.h"
#include "msql.h"


int sqlstart(char *host, int *port, char *user, char *pass)
{
   if ( mysql_init(&mysql) == NULL)return 1;
   if(!mysql_real_connect(&mysql,host,user,pass,NOMBREBD,0,NULL,0)){
      if(DEBUG) puts(mysql_error(&mysql));
      return 1;
   }
   return 0;
}

char ** sqlquery(char *query)
{
   //retorna 1 si error/no encuentra. 0 exito.
   MYSQL_RES *res;
   MYSQL_ROW row;
   int i=0,g1=0;
   char **guarda=NULL;
   if (mysql_query(&mysql,query)) {
      if(DEBUG)puts(mysql_error(&mysql));
      return NULL;
   }
   else 
     {
	res=mysql_store_result(&mysql);
	//g1=mysql_num_fields(res);
	guarda=calloc(1,(g1+1));//num resultados
	if((g1=mysql_num_rows(res))<1 || res==NULL)return NULL;
	while ((row= mysql_fetch_row(res)) != NULL)
	  {
	     /* Supongamos que solo necesitamos una variable de cada fila.
	      * Nos ahorra mucho trabajo y gestin de memoria.. An as hay
	      * que hacer el arreglo y guardar los datos en un doble array dinmico.
	      * Parece ser lo ms acertado tras horas de bsqueda inutil por google...
	      */
	     guarda[i]=calloc(1,(strlen(row[0])+1));
	     strcpy(guarda[i],row[0]);
	     //printf("%d->",i);
	     //puts(guarda[i]);
	     i++;
	  }
	guarda[g1]=NULL;
	//row = mysql_fetch_row(res);
	//guarda=row;
	//if(row[0]==NULL)puts("ERROR ######");
	//puts(guarda[0]);
	//mysql_free_result(res);
     } 
return guarda;
}
